export declare type GreaterFilter<Prop> = {
    readonly $gt: Prop;
} | {
    readonly $gte: Prop;
};
export declare type LesserFilter<Prop> = {
    readonly $lt: Prop;
} | {
    readonly $lte: Prop;
};
export declare type InFilter<Prop> = {
    readonly $in: Prop[];
} | {
    readonly $nin: Prop[];
};
export declare type EqualityFilter<Prop> = {
    readonly $eq: Prop;
} | {
    readonly $ne: Prop;
};
export declare type PropFilter<Prop> = (GreaterFilter<Prop> | LesserFilter<Prop> | InFilter<Prop> | EqualityFilter<Prop>);
export declare type EntityFilter<Entity> = {
    readonly [P in keyof Entity]?: Entity[P] | PropFilter<Entity[P]>;
};
export interface AndFilter<Entity> {
    readonly $and: Filter<Entity>[];
}
export interface OrFilter<Entity> {
    readonly $or: Filter<Entity>[];
}
export interface NotFilter<Entity> {
    readonly $not: Filter<Entity>;
}
export declare type Filter<Entity> = (EntityFilter<Entity> | AndFilter<Entity> | OrFilter<Entity> | NotFilter<Entity>);
export default Filter;
